; 
    include \masm32\include\masm32rt.inc
    include ECTimer2.inc
    includelib ECTimer2.lib

    NSAMPLES equ 4000
; 

    .data

      pcFreq      dq          0
      pcCount     dq          0
      period      dd          0
      periodTot   dd          0
      periodMin   dd          -1
      periodMax   dd          0
      periodMean  dd          0

      pBuff       dd          0
      sampleCount dd          NSAMPLES

      hEvent      dd          0

      tid         dd          0

      hInst       dd          0
      hWnd        dd          0
      _x          dd          0
      _y          dd          0
      wc          WNDCLASSEX  <>
      msg         MSG         <>
      className   db          "test_class",0

    .code
; 

; -------------------------------------------------------------
; This proc writes one or more null-terminated strings starting
; at the specified location, using the currently selected font,
; a transparent background, and the specified text color. After
; each string the starting location is updated based on the
; width of the string.
; -------------------------------------------------------------

szout proc C hdc:DWORD,
             xStart:DWORD,
             yStart:DWORD,
             textColor:DWORD,
             argCount:DWORD,
             args:VARARG

    LOCAL _size:_SIZE

    push ebx
    push esi
    push edi
    invoke SetBkMode, hdc, TRANSPARENT
    push eax
    invoke SetTextColor, hdc, textColor
    push eax
    mov esi, xStart
    lea edi, args
    xor ebx, ebx
  @@:
    invoke TextOut, hdc, esi, yStart, [edi+ebx*4], len([edi+ebx*4])

    ; ----------------------------------------------------------
    ; Avoid "error A2133: register value overwritten by INVOKE".
    ; ----------------------------------------------------------

    lea edx, _size
    invoke GetTextExtentPoint32, hdc, [edi+ebx*4], len([edi+ebx*4]), edx

    add esi, _size.x
    inc ebx
    cmp ebx, argCount
    jb @B
    pop eax
    invoke SetTextColor, hdc, eax
    pop eax
    invoke SetBkMode, hdc, eax
    pop edi
    pop esi
    pop ebx
    ret

szout endp

; 

TimerProc proc private uID:DWORD

    .IF DWORD PTR pcCount
      fild pcCount
      invoke QueryPerformanceCounter, ADDR pcCount
      fild pcCount
      fsubr
      fild pcFreq
      fdiv
      mov period, 1000000
      fild period
      fmul
      fistp period
      mov eax, period
      mov edx, pBuff
      mov ecx, sampleCount
      dec ecx
      mov [edx+ecx*4], eax
      dec sampleCount
      jnz @F
      invoke SetEvent, hEvent
    @@:
    .ELSE
      invoke QueryPerformanceCounter, ADDR pcCount
    .ENDIF

    ret

TimerProc endp

; 
start:
; 
    invoke GetMinPeriod
    .IF eax > 1
      MsgBox 0, chr$("MinPeriod > 1"), 0, 0
    .ENDIF

    mov pBuff, halloc(NSAMPLES*4)

    invoke QueryPerformanceFrequency, ADDR pcFreq

    invoke CreateEvent, NULL, FALSE, FALSE, NULL
    mov hEvent, eax

    mov hInst, rv(GetModuleHandle, NULL)
    mov wc.cbSize,        sizeof WNDCLASSEX
    mov wc.style,         CS_BYTEALIGNWINDOW
    mov wc.lpfnWndProc,   OFFSET WndProc
    mov wc.cbClsExtra,    NULL
    mov wc.cbWndExtra,    NULL
    m2m wc.hInstance,     hInst
    mov wc.hbrBackground, rv(GetStockObject, BLACK_BRUSH)
    mov wc.lpszMenuName,  NULL
    mov wc.lpszClassName, OFFSET className
    mov wc.hIcon,         rv(LoadIcon, NULL, IDI_APPLICATION)
    mov wc.hCursor,       rv(LoadCursor, NULL, IDC_ARROW)
    mov wc.hIconSm,       0
    invoke RegisterClassEx, ADDR wc

    W = 1010
    H = 435
    invoke GetSystemMetrics, SM_CXSCREEN
    shr eax, 1
    sub eax, W / 2
    mov _x, eax
    invoke GetSystemMetrics, SM_CYSCREEN
    shr eax, 1
    sub eax, H / 2
    mov _y, eax

    invoke CreateWindowEx, WS_EX_OVERLAPPEDWINDOW,
                           ADDR className,
                           chr$("Test"),
                           WS_OVERLAPPED or WS_SYSMENU,
                           _x, _y, W, H,
                           NULL, NULL,
                           hInst, NULL
    mov hWnd, eax

    invoke ShowWindow, hWnd, SW_SHOWNORMAL

    ; ---------------------------------------------------
    ; Wait for the sample collection to complete and kill
    ; the timer before calculating the statistics.
    ; ---------------------------------------------------

    invoke WaitForSingleObject, hEvent, INFINITE

    invoke EndTimer, tid

    mov esi, pBuff
    xor ebx, ebx
    .WHILE ebx < NSAMPLES
      mov eax, [esi+ebx*4]
      add periodTot, eax
      .IF eax < periodMin
        mov periodMin, eax
      .ELSEIF eax > periodMax
        mov periodMax, eax
      .ENDIF
      inc ebx
    .ENDW
    mov ecx, NSAMPLES
    mov eax, periodTot
    xor edx, edx
    div ecx
    mov periodMean, eax

    invoke UpdateWindow, hWnd

  msgLoop:

    invoke GetMessage, ADDR msg, NULL, 0, 0
    .IF (eax != 0)
      invoke TranslateMessage, ADDR msg
      invoke DispatchMessage, ADDR msg
      jmp   msgLoop
    .ENDIF

    invoke CloseHandle, hEvent
    hfree pBuff

    exit msg.wParam

; 

WndProc proc hwnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

    LOCAL rc:RECT
    LOCAL ps:PAINTSTRUCT

    SWITCH uMsg

      CASE WM_CREATE

        invoke BeginTimer, 1, ADDR TimerProc
        mov tid, eax

      CASE WM_PAINT

        invoke GetClientRect, hwnd, ADDR rc
        invoke BeginPaint, hwnd, ADDR ps

        ; --------------------------------------------
        ; Display the statistics and plot the results.
        ; --------------------------------------------

        invoke szout, ps.hdc, 20, 20, 0ff00h, 3,
                                    chr$("mean period = "),
                                    ustr$(periodMean),
                                    chr$("us")
        invoke szout, ps.hdc, 20, 45, 0ff00h, 3,
                                    chr$("minimum period = "),
                                    ustr$(periodMin),
                                    chr$("us")
        invoke szout, ps.hdc, 20, 70, 0ff00h, 3,
                                    chr$("maximum period = "),
                                    ustr$(periodMax),
                                    chr$("us")
        push ebx
        push esi
        mov esi, pBuff
        xor ebx, ebx
        .WHILE ebx < NSAMPLES
          mov eax, ebx
          mov ecx, 1000
          xor edx, edx
          div ecx
          mov eax, [esi+ebx*4]
          mov ecx, rc.bottom
          shr ecx, 1
          sub eax, 1000
          add eax, ecx
          invoke SetPixelV, ps.hdc, ebx, eax, 0ff00h
          inc ebx
        .ENDW
        pop esi
        pop ebx
        invoke EndPaint, hwnd, ADDR ps

      CASE WM_CLOSE

        invoke DestroyWindow, hwnd

      CASE WM_DESTROY

        invoke PostQuitMessage, NULL

      DEFAULT

        invoke DefWindowProc, hwnd, uMsg, wParam, lParam

    ENDSW

    ret

WndProc endp

; 

end start
